package cn.com.qmth.examcloud.web.support;

import java.util.Collections;

import org.apache.commons.lang3.RandomUtils;
import org.springframework.http.HttpEntity;
import org.springframework.http.HttpHeaders;
import org.springframework.http.HttpMethod;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import cn.com.qmth.examcloud.commons.logging.ExamCloudLog;
import cn.com.qmth.examcloud.commons.logging.ExamCloudLogFactory;
import cn.com.qmth.examcloud.commons.util.DateUtil;

/**
 * examcloud controller
 *
 * @author WANGWEI
 * @date 2018年8月23日
 * @Copyright (c) 2018-? http://qmth.com.cn All Rights Reserved.
 */
@RestController
public class ExamCloudController {

	protected static final ExamCloudLog LOG = ExamCloudLogFactory.getLog(ExamCloudController.class);

	@Naked
	@RequestMapping(value = {"/", ""}, method = RequestMethod.GET)
	public String get(@RequestParam(required = false) Boolean bug) {
		if (null != bug && bug) {
			if (RandomUtils.nextBoolean()) {
				throw new RuntimeException("Ha Ha Ha ... ...");
			}
		}
		return DateUtil.chinaNow();
	}

	@Naked
	@RequestMapping(value = {"/", ""}, method = RequestMethod.HEAD)
	public ResponseEntity<?> head() {
		return new ResponseEntity<Object>(HttpStatus.NO_CONTENT);
	}

	@Naked
	@RequestMapping(value = {"/", ""}, method = RequestMethod.OPTIONS)
	public HttpEntity<?> options() {
		HttpHeaders headers = new HttpHeaders();
		headers.setAllow(Collections.singleton(HttpMethod.GET));
		return new ResponseEntity<Object>(headers, HttpStatus.OK);
	}

	@Naked
	@RequestMapping(value = {"/", ""}, method = RequestMethod.POST)
	public String post() {
		return DateUtil.chinaNow();
	}

	@Naked
	@RequestMapping(value = {"/", ""}, method = RequestMethod.PUT)
	public String put() {
		return DateUtil.chinaNow();
	}

	@Naked
	@RequestMapping(value = {"/", ""}, method = RequestMethod.DELETE)
	public String delete() {
		return DateUtil.chinaNow();
	}

}
